'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _configurize = require('configurize');

var _configurize2 = _interopRequireDefault(_configurize);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _eventKit = require('event-kit');

var _dedent = require('dedent');

var _dedent2 = _interopRequireDefault(_dedent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('zog'),
    log = _require.log,
    warn = _require.warn,
    error = _require.error,
    debug = _require.debug;

var _default = function () {
  function _default() {
    (0, _classCallCheck3.default)(this, _default);
    this.services = {
      consume: {
        'app-server.service': { '1.0.0': 'consumeAppServerService' }
      }
    };
  }

  (0, _createClass3.default)(_default, [{
    key: 'consumeAppServerService',
    value: function consumeAppServerService(service) {
      var _this = this;

      service.addFirstMiddleware(this.getMiddleware());
      service.addHook('start-listening', function (koaApp) {
        // legacy method was 'app-server:listen'
        koaApp.httpServer.on('upgrade', function (req, socket, head) {
          if (req.url.indexOf('/webpack-dev-server-proxy') == -1) return;
          var newUrl = req.url.replace('/webpack-dev-server-proxy', '');
          req.url = newUrl;
          debug('Proxying websockets to:', newUrl);
          _this.proxy.ws(req, socket, head);
        });
      });
      return new _eventKit.Disposable(function () {});
    }
  }, {
    key: 'getMiddleware',
    value: function getMiddleware() {
      var middleware = [this.faviconMiddleware(), this.staticAssetsMiddleware(), this.appAssetsMiddleware()];
      return _lodash2.default.flatten(middleware);
    }
  }, {
    key: 'faviconMiddleware',
    value: function faviconMiddleware() {
      var favicon = require('koa-favicon');
      var convert = require('koa-convert');
      var mw = convert(favicon('public/favicon.ico'));
      mw._name = 'public/favicon.ico';
      return mw;
    }
  }, {
    key: 'staticAssetsMiddleware',
    value: function staticAssetsMiddleware() {
      var serveStatic = require('koa-serve-static');
      var mount = require('koa-mount-hot');
      var mw = mount('/public', serveStatic('public', {
        // NOTE: Must be false, otherwise server blocks.
        // See: https://github.com/expressjs/serve-static#fallthrough
        fallthrough: false
      }));
      mw._name = 'mount /public';
      return mw;
    }

    // Uses `http-proxy` module to forward requests to particular paths to webpack-dev-server.
    // NOTE: `koa-proxy` did not seem to work.

  }, {
    key: 'appAssetsMiddleware',
    value: function appAssetsMiddleware() {
      var _this2 = this;

      var middleware = [];

      // TODO(vjpr): Make this nicer.
      // Get dev server port.

      var _require2 = require('webpackerator'),
          webpackeratorUtils = _require2.webpackeratorUtils;

      var opts = webpackeratorUtils.parseOpts({} // TODO(vjpr): Not the best. Need single source of truth for config.
      // TODO(vjpr): Don't use this its super slow!
      //const webpackConfig = webpackeratorUtils.getConfig(opts)
      //const {port: webpackDevServerPort} = webpackConfig.devServer
      //// TODO(vjpr): Verify the dev-server corresponds to this project. There may my multiple running.
      );var webpackDevServerPort = opts.devServerPort || 8082;
      //

      console.log('Using webpack dev server on port:', webpackDevServerPort);

      var proxy = this.proxy = require('http-proxy').createProxyServer({
        target: { host: '0.0.0.0', port: webpackDevServerPort },
        ws: true
      });
      proxy.on('error', function (e) {
        if (e.code === 'ECONNREFUSED') {
          var errStr = '\n          Could not connect to webpack-dev-server.\n          A request was made which is to be forwarded to a webpack-dev-server.\n            -> Ensure it is running on port ' + webpackDevServerPort + ' by running \'gulp webpack:dev-server\'.\n          ';
          error((0, _dedent2.default)(errStr));
          return;
        }
        error('PROXY ERROR:', e);
      });
      var route = require('koa-route');

      var handler = function () {
        var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(ctx, next) {
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  ctx.respond = false;
                  console.log('proxying', ctx.request.url);
                  proxy.web(ctx.req, ctx.res);

                case 3:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this2);
        }));

        return function handler(_x, _x2) {
          return _ref.apply(this, arguments);
        };
      }();

      //
      // webpack-dev-server hot reloading
      //

      // NOTE: This handler is for webpack-dev-server hot reloading, not for asset serving.
      var webpackDevServerProxy = function () {
        var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(ctx, next) {
          var newUrl;
          return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  ctx.respond = false;
                  newUrl = ctx.req.url.replace('/webpack-dev-server-proxy', '');

                  ctx.req.url = newUrl;
                  //debug('Proxying:', ctx.req.url)
                  proxy.web(ctx.req, ctx.res);

                case 4:
                case 'end':
                  return _context2.stop();
              }
            }
          }, _callee2, _this2);
        }));

        return function webpackDevServerProxy(_x3, _x4) {
          return _ref2.apply(this, arguments);
        };
      }();

      // ---

      // TODO(vjpr): Should this be koa-mount-hot?
      function serveStaticMiddleware(mountPath, dir) {
        // NOTE: Nginx will prob be used so this is never hit.
        var serveStatic = require('koa-serve-static');
        var mount = require('koa-mount-hot'
        //const route = require('koa-route')
        );var middleware = mount(mountPath, serveStatic(dir, {
          //const middleware = route.get(mountPath, serveStatic(dir, {
          maxAge: 60000,
          etag: true
        }));
        middleware._name = 'koa-serve-static serveStaticMiddleware';
        return middleware;
      }

      var serveAssetsFromWebpackDevServer = _configurize2.default.get('envProps.serveAssetsFromWebpackDevServer');
      if (_lodash2.default.isUndefined(serveAssetsFromWebpackDevServer)) {
        serveAssetsFromWebpackDevServer = true;
      }
      console.log('Serving assets from webpack dev server: ' + serveAssetsFromWebpackDevServer);

      if (serveAssetsFromWebpackDevServer) {
        var mw = void 0;

        middleware.push(serveStaticMiddleware('/build-noproxy', 'build')
        //route.get('/hot/*', handler),

        );mw = route.get('/build/info', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
          return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  console.error('webpack-dev-server/client?=xxx is incorrect');
                  return _context3.abrupt('return');

                case 2:
                case 'end':
                  return _context3.stop();
              }
            }
          }, _callee3, _this2);
        })));
        mw._name = 'build/info';
        middleware.push(mw);

        mw = route.get('/build/*', handler);
        mw._name = '/build/*';
        middleware.push(mw);

        mw = route.all('/webpack-dev-server-proxy/*', webpackDevServerProxy);
        mw._name = '/webpack-dev-server-proxy/*';
        middleware.push(mw);
      } else {
        middleware.push(serveStaticMiddleware('/build', 'build'));
      }

      //redbirdProxy()

      return middleware;
    }
  }]);
  return _default;
}();

exports.default = _default;


function redbirdProxy() {

  // This is an alternative way to reverse proxy to webpack dev server and backend.
  var redbirdProxy = require('redbird')({
    port: 3001,
    bunyan: false // Disable logging.
  });
  redbirdProxy.register('localhost', 'http://localhost:3000');
  redbirdProxy.register('localhost/build', 'http://localhost:8081/build');
}
module.exports = exports['default'];
//# sourceMappingURL=live.js.map
